! -----------------------------------------------------------------------------
subroutine GFuseTLPclogistic_Ffunction(n,n_case,n_control,p,X,Xsd,Y,SubjectMap, &
			EdgeList,NodeDegree,TotalDegree,NodeWeight, &
			lambda1,lambda1_length,lambda2,lambda2_length,tau,tau_length, &
            MAXITER,eps,maxvarPercent,rho,EST_BETA,EST_Q1)
! -----------------------------------------------------------------------------
	implicit none
	! - - - arg types - - -
    integer :: n
    integer :: n_case
    integer :: n_control
    integer :: p
    integer :: lambda1_length
    integer :: lambda2_length
    integer :: tau_length
    integer :: MAXITER
    integer :: SubjectMap(n)
    integer :: NodeDegree(p)
    integer :: TotalDegree
    integer :: EdgeList(TotalDegree,2)
    double precision :: NodeWeight(p)
    double precision :: eps
    double precision :: maxvarPercent
    double precision :: rho
    double precision :: X(n,p)
    double precision :: Xsd(p)
    double precision :: Y(n)
    double precision :: lambda1(lambda1_length)
    double precision :: lambda2(lambda2_length)
    double precision :: tau(tau_length)
    double precision :: EST_BETA(p*lambda1_length*lambda2_length*tau_length)
    double precision :: EST_Q1(p*lambda1_length*lambda2_length*tau_length)
    ! - - - local declarations - - -
	integer :: i
    integer :: j
    integer :: lambda1_count
    integer :: lambda2_count
    integer :: tau_count
    integer :: beta_location
    integer :: numiter
    integer :: tuningparameter_length
    integer :: activeIndex(p)
    integer :: activeCount
    double precision :: T(TotalDegree,p)
    double precision :: Tbeta(TotalDegree)
    double precision :: Finv(p)
    double precision :: MU1(p)
    double precision :: Q1(p)
    double precision :: MU2(TotalDegree)
    double precision :: Q2(TotalDegree)
    double precision :: Bvector(p)
    double precision :: CTLPvector(p)
    double precision :: Cvector(p)
    double precision :: diff
    double precision :: templambda1
    double precision :: templambda2
    double precision :: templambdadifference
    double precision :: temptau
    double precision :: tempDerivj
    double precision :: tempDerivjvector(p)
    double precision :: tempDerivsecondvector(p)
    double precision :: Dj(p)
    double precision :: XYsum(p)
    double precision :: denominator
    double precision :: numerator
    double precision :: cycle_indicator
	double precision :: tempXcase(n_case,p)
    double precision :: tempXcontrol(n_control,p)
    double precision :: tempXcase_subset(n_case,p)
    double precision :: tempXcontrol_subset(n_control,p)
    double precision :: beta_pre(p)
    double precision :: Q1_pre(p)
    double precision :: beta(p)
    double precision :: TINY
    double precision :: maxabsbeta
    TINY = 0.00001
    
	tuningparameter_length = lambda1_length*tau_length*lambda2_length

	!OPEN(UNIT=12, FILE="aoutput_GFuseTLP.txt", ACTION="write", STATUS="replace")

	do i=1,n
    	! Note: Y takes on value of 1 (case) and 0 (control), 
        ! but easier to have double type
    	if(Y(i) > 0.5) then
			tempXcase(SubjectMap(i),:)=X(i,:)
        endif
        if(Y(i) < 0.5) then
			tempXcontrol(SubjectMap(i),:)=X(i,:)
        endif
    enddo
    variableloop: do j=1,p
    	!write(12,*) 'j is',j
        Dj(j)=0.0
        subjectloop: do i=1,n_case
        	!write(12,*) 'i is',i
        	!write(12,*) 'tempXcase(i,j) is',tempXcase(i,j)
            !write(12,*) 'tempXcontrol(i,j) is',tempXcontrol(i,j)
			Dj(j) = Dj(j) + ( max(tempXcase(i,j),tempXcontrol(i,j))- &
            				min(tempXcase(i,j),tempXcontrol(i,j)) )**2	
                          
        enddo subjectloop 
        Dj(j) = Dj(j)/4
        XYsum(j) = -1.0*dot_product(Y,X(:,j))
    enddo variableloop

	T=0.0
    do i=1,TotalDegree
		if(EdgeList(i,1) .lt. EdgeList(i,2)) then
			T(i,EdgeList(i,1)) = NodeWeight(EdgeList(i,1))
            T(i,EdgeList(i,2)) = NodeWeight(EdgeList(i,2))		
        endif
		if(EdgeList(i,1) .gt. EdgeList(i,2)) then
            T(i,EdgeList(i,1)) = -NodeWeight(EdgeList(i,1))
            T(i,EdgeList(i,2)) = NodeWeight(EdgeList(i,2))
		endif
	enddo

	do j=1,p
		Finv(j) = 1.0/( Dj(j)+rho+ & 
        		rho*2*NodeWeight(j)*NodeWeight(j)*NodeDegree(j) )
    enddo

    !write(12,*) 'XYsum is'
    !call printDoublevector(XYsum,p,1,p)
    !write(12,*) 'Dj is'
    !call printDoublevector(Dj,p,1,p)
    !write(12,*) 'Finv is'
    !call printDoublevector(Finv,p,1,p)
	!write(12,*) 'T is'
    !call printDoublematrix(T,TotalDegree,p, &
	!		1,1,TotalDegree,p)

	beta_location=1
    
    tau_loop: do tau_count=1,tau_length
    temptau = tau(tau_count)
    
    lambda2_loop: do lambda2_count=1,lambda2_length
    templambda2 = lambda2(lambda2_count)
    
    lambda1_loop: do lambda1_count=1,lambda1_length
		templambda1 = lambda1(lambda1_count)

		!write(12,*) 'tau_count is',tau_count 
        !write(12,*) 'temptau is',temptau
        !write(12,*) 'lambda2_count is',lambda2_count 
        !write(12,*) 'templambda2 is',templambda2 
        !write(12,*) 'lambda1_count is',lambda1_count
        !write(12,*) 'templambda1 is',templambda1

        maxabsbeta= 0.0

		if (lambda1_count .eq. 1) then
    	
			beta=0
            MU1=0
            Q1=0
            MU2=0
            Q2=0
            diff = 1
            numiter = 0
            activeCount = p
            activeIndex = 0
            cycle_indicator = 0.0
            while_loop1: do while(diff>eps .and. numiter<MAXITER)
            	numiter = numiter + 1
               	!write(12,*) 'numiter is',numiter
               	diff = 0
                beta_pre = beta
               	Q1_pre = Q1

                ! Step 1: update beta

                call DerivativeSecondpart(tempXcase,tempXcontrol, &
            		n_case,n_control,p,beta,p,activeIndex, &
                    tempDerivsecondvector)

				tempDerivjvector = (XYsum + tempDerivsecondvector)

				CTLPvector=0.0
                do j=1,p
					if(abs(beta(j)) > temptau) then
						CTLPvector(j) = templambda1/temptau* & 
                        				sign(DBLE(1.0),beta(j))
					endif
                enddo

                Cvector=0.0
                do j=1,p
					if(abs(beta(j)) > TINY) then
						Cvector(j) = templambda2* & 
                        	NodeDegree(j)*NodeWeight(j)*sign(DBLE(1.0),beta(j))
					endif
                enddo

				Bvector = rho*Q1 + rho*matmul(TRANSPOSE(T),Q2)+Dj*beta-MU1- &
                		matmul(TRANSPOSE(T),MU2)-tempDerivjvector+CTLPvector+Cvector

                beta = Bvector*Finv

				!write(12,*) 'beta is'
                !call printDoublevector(beta,p,1,p)

				! Step 2: update Q1,Q2

				call vectorST(beta+MU1/rho,templambda1/temptau/rho,p,Q1)

                !write(12,*) 'Q1 is'
                !call printDoublevector(Q1,p,1,p) 

                Tbeta = matmul(T,beta)

                call vectorST(Tbeta+MU2/rho,templambda2/rho,TotalDegree,Q2)

                !write(12,*) 'Q2 is'
                !call printDoublevector(Q2,TotalDegree,1,TotalDegree)
 
				! Step 3: update MU1, MU2

				MU1 = MU1 + rho*(beta-Q1)
				
				MU2 = MU2 + rho*(Tbeta-Q2)

                diff = dot_product(Q1-Q1_pre,Q1-Q1_pre)+dot_product(beta-beta_pre,beta-beta_pre)

				cycle_indicator=1.0 !@@@
                
                if (cycle_indicator>0) numiter=MAXITER+1
            enddo while_loop1
            ! to prepare for the following
            activeCount = 0

            beta=0.0 !@@@
            
		endif
        
		if (lambda1_count .gt. 1) then 

			! step 1): use strong rule to screen variables

            !write(12,*) 'Start Step 1 - update beta'

			if(activeCount .lt. floor(p*maxvarPercent)) then 

            	!write(12,*) 'enter condition if(activeCount .lt. floor(p*maxvarPercent))'
		
				call DerivativeSecondpart(tempXcase,tempXcontrol, &
            		n_case,n_control,p,beta,p,activeIndex, &
                    tempDerivsecondvector)

                !write(12,*) 'tempDerivsecondvector is'
                !call printDoublevector(tempDerivsecondvector,p,1,p)
                
				do j=1,p
					tempDerivj = (XYsum(j) + tempDerivsecondvector(j))
                	
                	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                	!Ctk = 0.0
                	!if(abs(beta(j)) > temptau) then
					!	Ctk = templambda1/temptau*sign(DBLE(1.0),beta(j))
                	!endif
                	!tempDerivj = tempDerivj - Ctk
                	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                	templambdadifference = 2*lambda1(lambda1_count)- &
                							lambda1(lambda1_count-1)
                	if(templambdadifference<0) then
						!write(12,*) 'templambdadifference is negative', &
                    	!					templambdadifference
                	endif
                      
                    !write(12,*) 'j is',j,'tempDerivj is',tempDerivj, &
                    !	'templambdadifference is',templambdadifference
                        
                	if(abs(tempDerivj) > (templambdadifference) ) then
						if(.not. any(activeIndex .eq. j)) then
							activeIndex(activeCount+1)=j
                        	activeCount = activeCount + 1
                    	endif
                	endif
            	enddo

            endif

            !write(12,*) 'activeCount is',activeCount
            !write(12,*) 'activeIndex is'
            !call printIntegervector(activeIndex,p,1,activeCount)

            ! step 2): run above algorithm on the reduce dataset

			do i=1,activeCount
				tempXcase_subset(:,i)=tempXcase(:,activeIndex(i))
                tempXcontrol_subset(:,i)=tempXcontrol(:,activeIndex(i))
            enddo	

            beta=0
            diff = 1
            numiter = 0
            cycle_indicator = 0.0
            MU1=0.0
            Q1=0.0
            MU2=0.0
            Q2=0.0
            
            while_loop2: do while(diff>eps .and. numiter<MAXITER .and. maxabsbeta < 20)
				numiter = numiter + 1
               	!write(12,*) 'numiter is',numiter
               	diff = 0
               	beta_pre = beta
                Q1_pre = Q1

				! Step 1: update beta
                    
				call DerivativeSecondpart(tempXcase_subset, & 
                		tempXcontrol_subset,n_case,n_control, &
            		p,beta,activeCount,activeIndex,tempDerivsecondvector)

				!write(12,*) 'tempDerivsecondvector is'
                !call printDoublevector(tempDerivsecondvector,p,1,p)

				tempDerivjvector = 0.0
				tempDerivjvector(1:activeCount) = (XYsum(activeIndex(1:activeCount)) + & 
                					tempDerivsecondvector(1:activeCount))

				!write(12,*) 'tempDerivjvector is'
                !call printDoublevector(tempDerivjvector,p,1,p)
                
                
				CTLPvector=0.0
                do j=1,activeCount
					if(abs(beta(j)) > temptau) then
						CTLPvector(j) = templambda1/temptau* & 
                        				sign(DBLE(1.0),beta(j))
					endif
                enddo

                !write(12,*) 'CTLPvector is'
                !call printDoublevector(CTLPvector,p,1,p)
                
                Cvector=0.0
                do j=1,activeCount
					if(abs(beta(j)) > TINY) then
						Cvector(j) = templambda2* & 
                        	NodeDegree(activeIndex(j))* &
                            NodeWeight(activeIndex(j))*sign(DBLE(1.0),beta(j))
					endif
                enddo

				!write(12,*) 'Cvector is'
                !call printDoublevector(Cvector,p,1,p)


				!write(12,*) 'Q1 is'
                !call printDoublevector(Q1,p,1,p)
                !write(12,*) 'rho*Q1 is'
                !call printDoublevector(rho*Q1,p,1,p) 
				!write(12,*) 'beta is'
                !call printDoublevector(beta,p,1,p) 
                !write(12,*) 'MU1 is'
                !call printDoublevector(MU1,p,1,p) 
                !write(12,*) 'T is'
                !call printDoublematrix(T,TotalDegree,p, &
				!						1,1,TotalDegree,p)
                !write(12,*) 'TRANSPOSE(T) is'
                !call printDoublematrix(TRANSPOSE(T),p,TotalDegree, &
				!						1,1,p,TotalDegree)
                !write(12,*) 'matmul(TRANSPOSE(T),MU2) is'
                !call printDoublevector(matmul(TRANSPOSE(T),MU2),p,1,p)
                !write(12,*) 'MU2 is'
                !call printDoublevector(MU2,TotalDegree,1,TotalDegree)
                !write(12,*) 'matmul(TRANSPOSE(T),MU2) is'
                !call printDoublevector(matmul(TRANSPOSE(T),MU2),p,1,p)
                

				Bvector=0.0  
				Bvector(1:activeCount) = Dj(activeIndex(1:activeCount))*beta(1:activeCount)+ &
                			CTLPvector(1:activeCount)+Cvector(1:activeCount)- &
                            tempDerivjvector(1:activeCount)- & 
                            MU1(1:activeCount)+rho*Q1(1:activeCount) + & 
							rho*matmul(TRANSPOSE(T(:,activeIndex(1:activeCount))),Q2)- &
                			matmul(TRANSPOSE(T(:,activeIndex(1:activeCount))),MU2)

                !write(12,*) 'Bvector is'
                !call printDoublevector(Bvector,p,1,p)

                beta=0.0
                beta(1:activeCount) = Bvector(1:activeCount)*Finv(activeIndex(1:activeCount))

				! Step 2: update Q1,Q2

                !write(12,*) 'Start Step 2 - update Q1, Q2'

				!write(12,*) 'templambda1/temptau/rho',templambda1/temptau/rho
                !write(12,*) 'beta is'
                !call printDoublevector(beta,p,1,p)
                !write(12,*) 'MU1 is'
                !call printDoublevector(MU1,p,1,p) 
				!write(12,*) 'MU1/rho'
                !call printDoublevector(MU1/rho,p,1,p)
				!write(12,*) 'beta+MU1/rho'
                !call printDoublevector(beta+MU1/rho,p,1,p)

				Q1 = 0.0
				call vectorST(beta(1:activeCount)+MU1(1:activeCount)/rho, &
                		templambda1/temptau/rho,activeCount,Q1(1:activeCount))

                Tbeta = matmul(T(:,activeIndex(1:activeCount)),beta(1:activeCount))

				!write(12,*) 'templambda2/rho',templambda2/rho
                !write(12,*) 'T is'
                !call printDoublematrix(T,TotalDegree,p,1,1,TotalDegree,p)
                !write(12,*) 'beta is'
                !call printDoublevector(beta,p,1,p)
                !write(12,*) 'Tbeta is'
				!call printDoublevector(Tbeta,TotalDegree,1,TotalDegree)                
				!write(12,*) 'MU2 is'
                !call printDoublevector(MU2,TotalDegree,1,TotalDegree)
                !write(12,*) 'MU2/rho is'
                !call printDoublevector(MU2/rho,TotalDegree,1,TotalDegree)
                !write(12,*) 'Tbeta+MU2/rho is'
                !call printDoublevector(Tbeta+MU2/rho,TotalDegree,1,TotalDegree)

                
                call vectorST(Tbeta+MU2/rho,templambda2/rho,TotalDegree,Q2)

				! Step 3: update MU1, MU2

                !write(12,*) 'Start Step 3 - update MU1, MU2'

				!write(12,*) 'MU1 before update is'
                !call printDoublevector(MU1,p,1,p)
                !write(12,*) 'rho is',rho
                !write(12,*) 'beta is'
                !call printDoublevector(beta,p,1,p)
                !write(12,*) 'Q1 is'
                !call printDoublevector(Q1,p,1,p)
                !write(12,*) 'beta-Q1 is'
                !call printDoublevector(beta-Q1,p,1,p)

				MU1 = 0.0
				MU1(1:activeCount) = MU1(1:activeCount) + &
                						rho*(beta(1:activeCount)-Q1(1:activeCount))
                                        
				!write(12,*) 'MU1 after update is'
				!call printDoublevector(MU1,p,1,p)
                
                !write(12,*) 'MU2 before update is'
                !call printDoublevector(MU2,TotalDegree,1,TotalDegree)
                !write(12,*) 'rho is',rho
                !write(12,*) 'Tbeta is'
                !call printDoublevector(Tbeta,TotalDegree,1,TotalDegree)
				!write(12,*) 'Q2 is'
                !call printDoublevector(Q2,TotalDegree,1,TotalDegree)
				!write(12,*) 'Tbeta-Q2 is'
                !call printDoublevector(Tbeta-Q2,TotalDegree,1,TotalDegree)

				MU2 = MU2 + rho*(Tbeta-Q2)

                !write(12,*) 'MU2 after update is'
                !call printDoublevector(MU2,TotalDegree,1,TotalDegree)

           		diff = dot_product(beta-beta_pre,beta-beta_pre)+ & 
                					dot_product(Q1-Q1_pre,Q1-Q1_pre)
                if (cycle_indicator>0) numiter=MAXITER+1
            enddo while_loop2
            ! translate beta subset to beta
            beta_pre = beta
            Q1_pre = Q1
            beta = 0
            Q1 = 0
            do j=1,activeCount
				beta(activeIndex(j))=beta_pre(j)
                if(abs(beta_pre(j)) > maxabsbeta) maxabsbeta=abs(beta_pre(j))
                Q1(activeIndex(j))=Q1_pre(j)
            enddo

            !write(12,*) 'beta is'
            !call printDoublevector(beta,p,1,p)
            !write(12,*) 'Q1 is'
            !call printDoublevector(Q1,p,1,p)

            ! step 3): check KKT conditions, if violated,
            ! 	add additional variables to activeIndex, go to step 1)

			if(activeCount .lt. floor(p*maxvarPercent)) then

				!write(12,*) 'check KKT condition'
            
				call DerivativeSecondpart(tempXcase,tempXcontrol, &
            		n_case,n_control,p,beta,p,activeIndex, &
                    tempDerivsecondvector)
				do j=1,p
					tempDerivj = (XYsum(j) + tempDerivsecondvector(j))

                	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                	!Ctk = 0.0
                	!if(abs(beta(j)) > temptau) then
					!	Ctk = templambda/temptau*sign(DBLE(1.0),beta(j))
                	!endif
					!tempDerivj = tempDerivj - Ctk
                	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                	if(abs(tempDerivj) > (templambda1/temptau) ) then
						if(.not. any(activeIndex .eq. j)) then
                    		!write(12,*) 'variable',j, &
                        	!	'violated KKT condition and added to activeIndex'
							activeIndex(activeCount+1)=j
                        	activeCount = activeCount + 1
                    	endif
                	endif
            	enddo

            endif

            !write(12,*) 'activeCount is',activeCount
            !write(12,*) 'activeIndex is'
            !call printIntegervector(activeIndex,p,1,activeCount)     

        endif

		EST_BETA(beta_location:(beta_location+p-1)) = beta
        EST_Q1(beta_location:(beta_location+p-1)) = Q1
		beta_location = beta_location + p
        
	enddo lambda1_loop
    enddo lambda2_loop
    enddo tau_loop

	! - - - standardization - - - 
	do i=1,tuningparameter_length
    	do j=1,p
    	EST_BETA((i-1)*p+j)=EST_BETA((i-1)*p+j)/Xsd(j)
        EST_Q1((i-1)*p+j)=EST_Q1((i-1)*p+j)/Xsd(j)
		enddo
    enddo

return
end subroutine GFuseTLPclogistic_Ffunction


! -----------------------------------------------------------------------------
subroutine vectorST(X,Lambda,vectorlength,ST_XLambda)
! -----------------------------------------------------------------------------
	implicit none
	! - - - arg types - - -
	integer :: vectorlength
    double precision :: X(vectorlength)
	double precision :: Lambda
    double precision :: ST_XLambda(vectorlength)
	! - - - local declarations - - -
    integer :: j

    do j=1,vectorlength
      	if(abs(X(j)) < Lambda) then
			ST_XLambda(j)=0.0
        else
			ST_XLambda(j) = sign(abs(X(j)) - Lambda,X(j)) 	
        endif
    enddo

return         
end subroutine vectorST

! -----------------------------------------------------------------------------
subroutine DerivativeSecondpart(Xcase,Xcontrol,n_case,n_control,p,beta, &
									activeCount,activeIndex,Deriv)
! -----------------------------------------------------------------------------
	implicit none
	! - - - arg types - - -
	integer :: n_case
    integer :: n_control
    integer :: p
    integer :: activeCount
    integer :: activeIndex(p)
    double precision :: Deriv(p)
    double precision :: Xcase(n_case,p)
    double precision :: Xcontrol(n_control,p)
    double precision :: beta(p)
	! - - - local declarations - - -
	integer :: i
    integer :: j
	double precision :: expXbeta1
    double precision :: expXbeta2
    double precision :: Xbeta1
    double precision :: Xbeta2
    double precision :: Xbeta2M1
    double precision :: weight
    
	! Note: this subroutine is called to check strong rule, hence all variables
    ! 	are used, along with original data matrix, not the subset matrix

	!write(12,*) 'enter DerivativeSecondpart'

	if(activeCount .eq. 0 .or. activeCount .eq. p) then

    	!write(12,*) 'enter condition if(activeCount .eq. 0 .or. activeCount .eq. p)'
    
    	variableloop: do j=1,p
    		Deriv(j)=0.0
			subjectloop: do i=1,n_case
				Xbeta1 = dot_product(Xcase(i,:),beta)
        		Xbeta2 = dot_product(Xcontrol(i,:),beta)
                Xbeta2M1 = Xbeta2 - Xbeta1
                
                if(Xbeta2M1 > 10) then 
					weight = 0.0001
                else 
                		if(Xbeta2M1 < -10) then
                        		weight = 0.9999
                        else
                          		weight = 1/(1.0+exp(Xbeta2M1))
                        endif 	
				endif

				Deriv(j) = Deriv(j) + (Xcase(i,j)*weight+ Xcontrol(i,j)*(1-weight)) 
			enddo subjectloop
    	enddo variableloop

	else 

		variableloop2: do j=1,activeCount
    		Deriv(j)=0.0
			subjectloop2: do i=1,n_case
				Xbeta1 = dot_product(Xcase(i,1:activeCount),beta(1:activeCount))
        		Xbeta2 = dot_product(Xcontrol(i,1:activeCount),beta(1:activeCount))
                
				Xbeta2M1 = Xbeta2 - Xbeta1
                
                if(Xbeta2M1 > 10) then 
					weight = 0.0001
                else 
                		if(Xbeta2M1 < -10) then
                        		weight = 0.9999
                        else
                          		weight = 1/(1.0+exp(Xbeta2M1))
                        endif 	
				endif
					
				!write(12,*) 'enter else condition'
				!Deriv(j) = Deriv(j) + (Xcase(i,j)*weight+ Xcontrol(i,j)*(1-weight))  
                !write(12,*) 'j is ',j,' i is ',i,' weight is ',weight,' Deriv(j) is ',Deriv(j)
                        
			enddo subjectloop2
    	enddo variableloop2
        Deriv((activeCount+1):p) = 0.0
    
    endif

return
end subroutine DerivativeSecondpart

! -----------------------------------------------------------------------------
subroutine printIntegervector(vec,vec_length,startpos,endpos)
! -----------------------------------------------------------------------------
	implicit none

    integer :: vec_length
    integer :: startpos
    integer :: endpos
    integer :: vec(vec_length)
    integer :: i
    write(12,*) 'print vector'
    do i=startpos,endpos
    	write(12,*) vec(i),' '
    enddo
    write(12,*) ''

return
end subroutine printIntegervector

! -----------------------------------------------------------------------------
subroutine printDoublevector(vec,vec_length,startpos,endpos)
! -----------------------------------------------------------------------------
	implicit none

    integer :: vec_length
    integer :: startpos
    integer :: endpos
    double precision :: vec(vec_length)
    integer :: i
    write(12,*) 'print vector'
    do i=startpos,endpos
    	write(12,*) i,' ',vec(i),' '
    enddo
    write(12,*) ''

return
end subroutine printDoublevector
	

! -----------------------------------------------------------------------------
subroutine printDoublematrix(mat,mat_nrow,mat_ncol, &
			startrow,startcol,endrow,endcol)
! -----------------------------------------------------------------------------
	implicit none

	integer :: mat_nrow
    integer :: mat_ncol
    integer :: startrow
    integer :: startcol
    integer :: endrow
    integer :: endcol
    double precision :: mat(mat_nrow,mat_ncol)
    integer :: i
    integer :: j
    write(12,*) 'print matrix'
    write(12,*) 'startrow is',startrow,'startcol is',startcol, & 
    				'endrow is',endrow,'endcol is',endcol
    outer: do i=startrow,endrow
		inner: do j=startcol,endcol
			write(12,*) mat(i,j),' ' 
    	enddo inner
        write(12,*) ''
    enddo outer
    write(12,*) ''
    
return
end subroutine printDoublematrix


            