! -----------------------------------------------------------------------------
subroutine Lassoclogistic_Ffunction(n,n_case,n_control,p,X,Xsd,Y,SubjectMap, &
				lambda,lambda_length,MAXITER,eps,maxvarPercent,EST_BETA)
! -----------------------------------------------------------------------------
	implicit none
	! - - - arg types - - -
    integer :: n
    integer :: n_case
    integer :: n_control
    integer :: p
    integer :: lambda_length
    integer :: MAXITER
    integer :: SubjectMap(n)
    double precision :: eps
    double precision :: maxvarPercent
    double precision :: X(n,p)
    double precision :: Xsd(p)
    double precision :: Y(n)
    double precision :: lambda(lambda_length)
    double precision :: EST_BETA(p*lambda_length)
    ! - - - local declarations - - -
	integer :: i
    integer :: j
    integer :: lambda_count
    integer :: beta_location
    integer :: numiter
    integer :: tuningparameter_length
    integer :: activeIndex(p)
    integer :: activeCount
    double precision :: u
    double precision :: v
    double precision :: diff
    double precision :: templambda
    double precision :: templambdadifference
    double precision :: tempDerivj
    double precision :: tempDerivjsecond
    double precision :: tempDerivsecondvector(p)
	double precision :: Dj(p)
    double precision :: XYsum(p)
    double precision :: denominator
    double precision :: numerator
    double precision :: cycle_indicator
	double precision :: tempXcase(n_case,p)
    double precision :: tempXcontrol(n_control,p)
    double precision :: tempXcase_subset(n_case,p)
    double precision :: tempXcontrol_subset(n_control,p)
    double precision :: beta_pre(p)
    double precision :: beta(p)
    double precision :: beta_pre_j
    double precision :: XcaseBetaSum(n_case)
    double precision :: XcontrolBetaSum(n_control)
	tuningparameter_length = lambda_length

	!OPEN(UNIT=12, FILE="aoutput.txt", ACTION="write", STATUS="replace")

	do i=1,n
    	! Note: Y takes on value of 1 (case) and 0 (control), 
        ! but easier to have double type
    	if(Y(i) > 0.5) then
			tempXcase(SubjectMap(i),:)=X(i,:)
        endif
        if(Y(i) < 0.5) then
			tempXcontrol(SubjectMap(i),:)=X(i,:)
        endif
    enddo
    variableloop: do j=1,p
    	!write(12,*) 'j is',j
		Dj(j)=0
        subjectloop: do i=1,n_case
        	!write(12,*) 'i is',i
        	!write(12,*) 'tempXcase(i,j) is',tempXcase(i,j)
            !write(12,*) 'tempXcontrol(i,j) is',tempXcontrol(i,j)
			Dj(j) = Dj(j) + ( max(tempXcase(i,j),tempXcontrol(i,j))- &
            				min(tempXcase(i,j),tempXcontrol(i,j)) )**2	
                          
        enddo subjectloop 
        Dj(j) = Dj(j)/4/n
        XYsum(j) = -1.0*dot_product(Y,X(:,j))
    enddo variableloop

	!write(12,*) 'Dj vector is'
    !call printDoublevector(Dj,p,1,p)
    !write(12,*) 'XYsum is'
    !call printDoublevector(XYsum,p,1,p)

	beta_location=1
    lambda_loop: do lambda_count=1,lambda_length
		templambda = lambda(lambda_count)
        
		if (lambda_count .eq. 1) then
    	
            !write(12,*) 'lambda_count is',lambda_count
            !write(12,*) 'templambda is',templambda
			beta=0
            diff = 1
            numiter = 0
            activeCount = p
            activeIndex = 0
            cycle_indicator = 0.0
            while_loop1: do while(diff>eps .and. numiter<MAXITER)
            	numiter = numiter + 1
               	!write(12,*) 'numiter is',numiter
               	diff = 0
               	beta_pre = beta
               	beta_loop1: do j=1,p
               		!write(12,*) 'j is',j
                   	tempDerivj = XYsum(j)
					call Lasso_DerivativeSecondpart_j(tempXcase,tempXcontrol, &
                    			n_case,n_control,p,beta,activeCount, &
								j,tempDerivjsecond)
                    tempDerivj = (tempDerivj + tempDerivjsecond)/n
                   	!write(12,*) 'tempDerivj is',tempDerivj
                   	u = Dj(j)*beta(j)-tempDerivj
                   	!write(12,*) 'u is',u
                   	v = templambda
                   	!write(12,*) 'v is',v
                   	if(abs(u) <= v) then 
               			beta(j)=0
                   	else
						numerator = sign(abs(u) - v,u)
                   		denominator = Dj(j)
						beta(j) = numerator / denominator
					endif
                    !write(12,*) 'beta(j) is',beta(j)
                enddo beta_loop1
				diff = dot_product(beta-beta_pre,beta-beta_pre)
                if (cycle_indicator>0) numiter=MAXITER+1
            enddo while_loop1
            ! to prepare for the following
            activeCount = 0
		endif		
        
		if (lambda_count .gt. 1) then    

			!write(12,*) 'lambda_count is',lambda_count
            !write(12,*) 'beta is'
            !call printDoublevector(beta,p,1,p)
	
			! step 1): use strong rule to screen variables

            if(activeCount .lt. floor(p*maxvarPercent)) then

				call Lasso_DerivativeSecondpart(tempXcase,tempXcontrol, &
            			n_case,n_control,p,beta,tempDerivsecondvector)
				do j=1,p
					tempDerivj = XYsum(j)
					tempDerivj = (tempDerivj + tempDerivsecondvector(j))/n
                	templambdadifference = 2*lambda(lambda_count)- &
                							lambda(lambda_count-1)
                	if(templambdadifference<0) then
						!write(12,*) 'templambdadifference is negative', &
                    	!					templambdadifference
                	endif
                	if(abs(tempDerivj) > templambdadifference ) then
						if(.not. any(activeIndex .eq. j)) then
							activeIndex(activeCount+1)=j
                        	activeCount = activeCount + 1
                    	endif
                	endif
            	enddo
                  
            endif

            !write(12,*) 'activeCount is',activeCount
            !write(12,*) 'activeIndex is'
            !call printIntegervector(activeIndex,p,1,activeCount)

            ! step 2): run above algorithm on the reduce dataset

			! reduce the size of X matrix
            do i=1,activeCount
				tempXcase_subset(:,i)=tempXcase(:,activeIndex(i))
                tempXcontrol_subset(:,i)=tempXcontrol(:,activeIndex(i))
            enddo

			XcaseBetaSum = 0.0
    		XcontrolBetaSum = 0.0
            
			!write(12,*) 'templambda is',templambda
        	beta=0
            diff = 1
            numiter = 0
            cycle_indicator = 0.0
            while_loop2: do while(diff>eps .and. numiter<MAXITER)
				numiter = numiter + 1
               	!write(12,*) 'numiter is',numiter
               	diff = 0
               	beta_pre = beta
               	beta_loop2: do j=1,activeCount
               		!write(12,*) 'j is',j

                    beta_pre_j = beta(j)
                    
                    tempDerivj = XYsum(activeIndex(j))
                    !call Lasso_DerivativeSecondpart_j(tempXcase_subset, &
                    !		tempXcontrol_subset,n_case,n_control, &
                    !        p,beta,activeCount,j,tempDerivjsecond)

					call Lasso_DerivativeSecondpart_j_acc(XcaseBetaSum, &
                    		XcontrolBetaSum,tempXcase_subset(:,j), &
                            tempXcontrol_subset(:,j), &
                            n_case,n_control,tempDerivjsecond) 
                            
                    tempDerivj = (tempDerivj + tempDerivjsecond)/n
                   	!write(12,*) 'tempDerivj is',tempDerivj
                   	u = Dj(activeIndex(j))*beta(j)-tempDerivj        
					!write(12,*) 'u is',u
                   	v = templambda
                   	!write(12,*) 'v is',v
                   	if(abs(u) <= v) then 
               			beta(j)=0
                   	else
						numerator = sign(abs(u) - v,u)
                   		denominator = Dj(activeIndex(j))
						beta(j) = numerator / denominator
					endif
                    !write(12,*) 'beta(j) is',beta(j)

					XcaseBetaSum = XcaseBetaSum + (beta(j)-beta_pre_j)*tempXcase_subset(:,j)
                    XcontrolBetaSum = XcontrolBetaSum + (beta(j)-beta_pre_j)*tempXcontrol_subset(:,j)
                    
				enddo beta_loop2
				diff = dot_product(beta-beta_pre,beta-beta_pre)
                if (cycle_indicator>0) numiter=MAXITER+1
            enddo while_loop2
            ! translate beta subset to beta
            beta_pre = beta
            beta = 0
            do j=1,activeCount
				beta(activeIndex(j))=beta_pre(j)
            enddo
            
			! step 3): check KKT conditions, if violated,
            ! 	add additional variables to activeIndex, go to step 1)

			if(activeCount .lt. floor(p*maxvarPercent)) then
                  
				!write(12,*) 'check KKT condition'
            
				call Lasso_DerivativeSecondpart(tempXcase,tempXcontrol, &
            		n_case,n_control,p,beta,tempDerivsecondvector)
				do j=1,p
					tempDerivj = XYsum(j)
					tempDerivj = (tempDerivj + tempDerivsecondvector(j))/n

                	if(abs(tempDerivj) > templambda ) then
						if(.not. any(activeIndex .eq. j)) then
                    		!write(12,*) 'variable',j, &
                        	!	'violated KKT condition and added to activeIndex'
							activeIndex(activeCount+1)=j
                        	activeCount = activeCount + 1
                    	endif
                	endif
            	enddo

            endif

            !write(12,*) 'activeCount is',activeCount
            !write(12,*) 'activeIndex is'
            !call printIntegervector(activeIndex,p,1,activeCount)

        endif

		EST_BETA(beta_location:(beta_location+p-1)) = beta
		beta_location = beta_location + p
	enddo lambda_loop

	! - - - standardization - - - 
	do i=1,tuningparameter_length
    	do j=1,p
    	EST_BETA((i-1)*p+j)=EST_BETA((i-1)*p+j)/Xsd(j)
		enddo
    enddo

return
end subroutine Lassoclogistic_Ffunction


! -----------------------------------------------------------------------------
subroutine Lasso_DerivativeSecondpart_j_acc(XcaseBetaSum,XcontrolBetaSum, &
				Xcase_j,Xcontrol_j,n_case,n_control,Deriv_j)
! -----------------------------------------------------------------------------
	implicit none
    ! - - - arg types - - -
	integer :: n_case
    integer :: n_control              
    double precision :: Deriv_j
    double precision :: XcaseBetaSum(n_case)
    double precision :: XcontrolBetaSum(n_control)
    double precision :: Xcase_j(n_case)
    double precision :: Xcontrol_j(n_control)
    ! - - - local declarations - - -
    integer :: i
	double precision :: expXbeta1
    double precision :: expXbeta2

    Deriv_j = 0.0
	do i=1,n_case
    	expXbeta1 = exp(XcaseBetaSum(i))
        expXbeta2 = exp(XcontrolBetaSum(i))
		Deriv_j = Deriv_j + (Xcase_j(i)*expXbeta1+ &
                        Xcontrol_j(i)*expXbeta2)/(expXbeta1+expXbeta2)    
	enddo
return
end subroutine Lasso_DerivativeSecondpart_j_acc
                    
! -----------------------------------------------------------------------------
subroutine Lasso_DerivativeSecondpart_j(Xcase,Xcontrol,n_case,n_control,p,beta, &
									activeCount,j,Deriv_j)
! -----------------------------------------------------------------------------
	implicit none
    ! - - - arg types - - -
	integer :: n_case
    integer :: n_control
    integer :: p
	integer :: j
    integer :: activeCount
    double precision :: Deriv_j
    double precision :: Xcase(n_case,p)
    double precision :: Xcontrol(n_control,p)
    double precision :: beta(p)
	! - - - local declarations - - -
    integer :: i
    double precision :: expXbeta1
    double precision :: expXbeta2
	
	Deriv_j = 0.0
	if(activeCount .eq. p) then
		do i=1,n_case
			expXbeta1 = exp(dot_product(Xcase(i,:),beta))
        	expXbeta2 = exp(dot_product(Xcontrol(i,:),beta))
			Deriv_j = Deriv_j + (Xcase(i,j)*expXbeta1+ &
                        Xcontrol(i,j)*expXbeta2)/(expXbeta1+expXbeta2)    
		enddo
    endif
    
	! Note: when activeCount < p, the index j is the NOT the original variable j,
    ! 	but the mapped j. We should have 1<=j<=activeCount
	if(activeCount .lt. p) then    
		do i=1,n_case
			expXbeta1 = exp(dot_product(Xcase(i,1:activeCount),beta(1:activeCount)))
        	expXbeta2 = exp(dot_product(Xcontrol(i,1:activeCount),beta(1:activeCount)))
			Deriv_j = Deriv_j + (Xcase(i,j)*expXbeta1+ &
                        Xcontrol(i,j)*expXbeta2)/(expXbeta1+expXbeta2)
        enddo
	endif

return
end subroutine Lasso_DerivativeSecondpart_j

! -----------------------------------------------------------------------------
subroutine Lasso_DerivativeSecondpart(Xcase,Xcontrol,n_case,n_control,p,beta,Deriv)
! -----------------------------------------------------------------------------
	implicit none
	! - - - arg types - - -
	integer :: n_case
    integer :: n_control
    integer :: p
    double precision :: Deriv(p)
    double precision :: Xcase(n_case,p)
    double precision :: Xcontrol(n_control,p)
    double precision :: beta(p)
	! - - - local declarations - - -
	integer :: i
    integer :: j
	double precision :: expXbeta1
    double precision :: expXbeta2
    
	! Note: this subroutine is called to check strong rule, hence all variables
    ! 	are used, along with original data matrix, not the subset matrix
    variableloop: do j=1,p
    	Deriv(j)=0.0
		subjectloop: do i=1,n_case
			expXbeta1 = exp(dot_product(Xcase(i,:),beta))
        	expXbeta2 = exp(dot_product(Xcontrol(i,:),beta))
			Deriv(j) = Deriv(j) + (Xcase(i,j)*expXbeta1+ &
                        Xcontrol(i,j)*expXbeta2)/(expXbeta1+expXbeta2)   
		enddo subjectloop
    enddo variableloop
	
return
end subroutine Lasso_DerivativeSecondpart


            